<sw-page>

    <template #smart-bar-header>
        <h2>
            {{ metaTitle }}
        </h2>
    </template>

    <template #language-switch>

        <sw-language-switch
            :save-changes-function="saveOnLanguageChange"
            :abort-change-function="abortOnLanguageChange"
            :disabled="newSlide === true"
            @on-change="onChangeLanguage"
        />
    </template>

    <template #smart-bar-actions>

        <sw-button
            :disabled="(newSlide !== true && !hasChanges)"
            v-tooltip="{
                message: cancelActionMessage
            }"
            @click="cancelAction">
            {{ $tc('sw-customer.detail.buttonCancel') }}
        </sw-button>

        <sw-button-group
            :split-button="true">

            <sw-button-process
                :is-loading="isLoading"
                :disabled="!(permissionCreate || permissionEdit)"
                variant="primary"
                @click.prevent="saveSlide"
            >
                {{ $tc('sw-customer.detail.buttonSave') }}
            </sw-button-process>

            <sw-context-button
                v-if="newSlide !== true">

                <template #button>
                    <sw-button
                        square
                        variant="primary"
                        :disabled="isLoading"
                    >
                        <blur-icon
                            name="blurph-caret-down-bold"
                            size="24"
                        />
                    </sw-button>
                </template>

                <sw-context-menu-item
                    :disabled="!permissionCreate"
                    @click="onCopySlide">
                    {{ $tc('blurElysiumSlides.actions.copySlide') }}
                </sw-context-menu-item>

                <sw-context-menu-item
                    variant="danger"
                    :disabled="!permissionDelete"
                    @click="permissionDelete === true ? showDeleteModal = true : null">
                    {{ $tc('blurElysiumSlides.actions.deleteSlide') }}
                </sw-context-menu-item>

            </sw-context-button>

        </sw-button-group>
    </template>

    <template #content>

        <div v-if="slide"
            :style="viewStyle({ 
                mobile: { 'padding': '16px' } 
            })">

            <sw-tabs
                position-identifier="positionIdentifiers.placeholder">

                <sw-tabs-item
                    :route="contentRoute"
                    :title="$tc('blurElysiumSlides.settings.baseLabel')"
                    :hasError="tabContentHasError">
                    {{ $tc('blurElysiumSlides.settings.baseLabel') }}
                </sw-tabs-item>

                <sw-tabs-item
                    :route="mediaRoute"
                    :title="$tc('blurElysiumSlides.settings.mediaLabel')">
                    {{ $tc('blurElysiumSlides.settings.mediaLabel') }}
                </sw-tabs-item>

                <sw-tabs-item
                    :route="displayRoute"
                    :title="$tc('blurElysium.general.appearance')">
                    {{ $tc('blurElysium.general.appearance') }}
                </sw-tabs-item>

                <sw-tabs-item
                    :route="advancedRoute"
                    :title="$tc('blurElysiumSlides.settings.advancedLabel')"
                    :hasWarning="tabAdvancedHasWarning"
                    :warningTooltip="tabAdvancedWarningMessage">
                    {{ $tc('blurElysiumSlides.settings.advancedLabel') }}
                </sw-tabs-item>

                <template #content>
                    <router-view />
                </template>
            </sw-tabs>        
        </div>



        <sw-confirm-modal 
            v-if="showDeleteModal === true" 
            type="delete"
            :title="$tc('blurElysiumSlides.actions.deleteSlide')"
            :text="$tc('blurElysiumSlides.messages.slideDeleteConfirm')"
            @confirm="deleteSlide"
            @cancel="showDeleteModal = false"
            @close="showDeleteModal = false" />

    </template>

    <template #sidebar>

        <sw-sidebar 
            :propagate-width="true">

            <sw-sidebar-media-item 
                :ref="(el) => { setMediaSidebar(el) }">

                <template #context-menu-items="media">
                    
                    <sw-context-menu-item 
                        v-if="mediaType(media.mediaItem.mimeType) === 'image'"
                        @click="setSlideCoverImage(media.mediaItem)">
                        {{ $tc('blurElysiumSlides.forms.useMediaAsSlideCover') }}
                    </sw-context-menu-item>

                    <sw-context-menu-item 
                        v-if="mediaType(media.mediaItem.mimeType) === 'video'"
                        @click="setSlideCoverVideo(media.mediaItem)">
                        {{ $tc('blurElysiumSlides.forms.useMediaAsSlideCover') }}
                    </sw-context-menu-item>

                    <sw-context-menu-item 
                        v-if="mediaType(media.mediaItem.mimeType) === 'image'"
                        @click="setFocusImage(media.mediaItem)">
                        {{ $tc('blurElysiumSlides.forms.useMediaAsFocusImage') }}
                    </sw-context-menu-item>

                </template>

            </sw-sidebar-media-item>

        </sw-sidebar>
    </template>

</sw-page>